proc GetInfoLib { index } {
# Scan an Existing Library
	global Obj_Lib Obj_Libar Obj_Dir Glob_Pref CheckLevel Process

	if [ info exists Obj_Lib($index) ] {
		show-status "Get infos for lib $Obj_Lib($index)" lib-status
	} else {
		show-status "No Lib with index : $index" main-status
		return
	}

	set trace_type lib
	set trace_id $index
	set Process($trace_type,checking,$trace_id) {start checking}

	set Obj_Lib($index,status)	{}

	# Get the *.$Glob_Pref(FortranExt) list
	set Obj_Lib($index,list_regf) \
		[cd $Obj_Dir(Lib)/$Obj_Lib($index) ; glob -nocomplain *.$Glob_Pref(FortranExt)]
	set Obj_Lib($index,list_regf) [lsort -ascii $Obj_Lib($index,list_regf)]

	set nb_regf [ llength  $Obj_Lib($index,list_regf) ]
	if [info exists Obj_Lib($index,nb_regf)] {
	 set Obj_Lib($index,nb_regf_old) $Obj_Lib($index,nb_regf)
	} else {
	 set Obj_Lib($index,nb_regf_old) $nb_regf
	}
	 set Obj_Lib($index,nb_regf) $nb_regf

	# Get the {*.errcp} list
	set Obj_Lib($index,list_errcp) \
		[cd $Obj_Dir(Lib)/$Obj_Lib($index) ; glob -nocomplain *.errcp]
	set Obj_Lib($index,list_errcp) [lsort -ascii $Obj_Lib($index,list_errcp)]

	set nb_errcp [ llength  $Obj_Lib($index,list_errcp) ]
	if [info exists Obj_Lib($index,nb_errcp)] {
	 set Obj_Lib($index,nb_errcp_old) $Obj_Lib($index,nb_errcp)
	} else {
	 set Obj_Lib($index,nb_errcp_old) $nb_errcp
	}
	 set Obj_Lib($index,nb_errcp) $nb_errcp

	# Build a list of .$Glob_Pref(FortranExt) files for which
	# (re-)compilation should be done, because :

	set Obj_Lib($index,list_recf) {}

	PRINT "Checking Library $Obj_Lib($index)"

	if ![file exists $Obj_Lib($index,libar)] {

# Level 1	# Archive doesn't exist !, so select all fortran files :

	   set flag_check 1
           if {$CheckLevel(lib,$flag_check,flag)} {
		set Process($trace_type,checking,$trace_id) "Check level #${flag_check}"
		set Obj_Lib($index,list_recf) $Obj_Lib($index,list_regf)
		lappend Obj_Lib($index,status) \
				"Check Level #$flag_check :\nArchive doesn't exist !"
	   }

	} else {

# Level 2	# Or some files are still bugged :
		# Of course they may have been modified, but !,
		# fPW don't know yet if they are Ok !

	   set flag_check 2
           if {$CheckLevel(lib,$flag_check,flag)} {
		set Process($trace_type,checking,$trace_id) "Check level #${flag_check}"
		set iflag 0 ; set checklist {}
		foreach fileerrcp $Obj_Lib($index,list_errcp) {
			regsub "\.errcp$" $fileerrcp .$Glob_Pref(FortranExt) file_f
			lappend Obj_Lib($index,list_recf) $file_f

			incr iflag
			lappend checklist "File: $file_f"
		}
		if {$iflag} {
			lappend Obj_Lib($index,status) \
				"Check Level #$flag_check :\n$iflag Bugged File(s) !"
			lappend Obj_Lib($index,status) $checklist
		}
	   }

# Level 3	# And/Or some files are newer that the existing archive :
		# This might occurs naturally when Fortran files are modified ...
		# (don't forget to reject those already selected by previous check !)

	   set flag_check 3
           if {$CheckLevel(lib,$flag_check,flag)} {
		set Process($trace_type,checking,$trace_id) "Check level #${flag_check}"
		set iflag 0 ; set checklist {}
		set fileref $Obj_Lib($index,libar)
		foreach file_f $Obj_Lib($index,list_regf) {
			if [newer $file_f $fileref] {
			 	set Obj_Lib($index,list_recf) \
					[AppendItemInList $Obj_Lib($index,list_recf) $file_f]
				incr iflag
				lappend checklist "File: $file_f"
			}
		}
		if {$iflag} {
			lappend Obj_Lib($index,status) \
				"Check Level #$flag_check :\n$iflag Newer File(s) vs Archive !"
			lappend Obj_Lib($index,status) $checklist
		}
	   }

# Level 4	# And/Or there are still some Object files (*.o)
		# This might occurs if the library updating process is killed,
		# so, remaining Object modules are not archived then cleaned ....
		# (don't forget to reject those already selected by previous check !)

	   set flag_check 4
           if {$CheckLevel(lib,$flag_check,flag)} {
		set Process($trace_type,checking,$trace_id) "Check level #${flag_check}"
		set iflag 0 ; set checklist {}
		set listobj \
			[cd $Obj_Dir(Lib)/$Obj_Lib($index) ; glob -nocomplain *.o]
		foreach fileobj $listobj {
			regsub "\.o$" $fileobj .$Glob_Pref(FortranExt) file_f
			set Obj_Lib($index,list_recf) \
				[AppendItemInList $Obj_Lib($index,list_recf) $file_f]
				incr iflag
				lappend checklist "File: $file_f"
		}

		if {$iflag} {
			lappend Obj_Lib($index,status) \
				"Check Level #$flag_check :\n$iflag File(s) with remaining Object Module (?)"
			lappend Obj_Lib($index,status) $checklist
		}
	   }
	}


# Level 5	# And/Or missing object modulesd in archive
		# (don't forget to reject those already selected by previous check !)

	   set flag_check 5
           if {$CheckLevel(lib,$flag_check,flag)} {
		set Process($trace_type,checking,$trace_id) "Check level #${flag_check}"
		set iflag 0 ; set checklist {}
		if [catch {eval exec $Glob_Pref(Ar) t $Obj_Lib($index,libar)} listobj] {
			PRINT "proc infolib :\nTkfPW Warning ! :\n\n$listobj"
			set listobj {}
		}
		foreach file_f $Obj_Lib($index,list_regf) {
				regsub "\.$Glob_Pref(FortranExt)$" $file_f .o file_o
				if [ ItemIsNotInList $file_o $listobj] {
					set Obj_Lib($index,list_recf) \
						[AppendItemInList $Obj_Lib($index,list_recf) $file_f]
					incr iflag
					lappend checklist "File: $file_f"
				}			
		}
		if {$iflag} {
			lappend Obj_Lib($index,status) \
				"Check Level #$flag_check :\n$iflag File(s) with no Object Module in archive (?)"
			lappend Obj_Lib($index,status) $checklist
		}
	   }

	set Process($trace_type,checking,$trace_id) {end checking}

	set nb_recf [ llength  $Obj_Lib($index,list_recf) ]

	if [info exists Obj_Lib($index,nb_recf)] {
	 set Obj_Lib($index,nb_recf_old) $Obj_Lib($index,nb_recf)
	} else {
	 set Obj_Lib($index,nb_recf_old) $nb_recf
	}
	 set Obj_Lib($index,nb_recf) $nb_recf

	if { $Obj_Lib($index,nb_recf) > 0 } {
		show-status "$Obj_Lib($index,nb_recf) File(s) To Update" lib-status
		return [list "Library $Obj_Lib($index) needs (Re-)Building"]
	} else {
		CheckLevelStatus lib
		if {$CheckLevel(lib,on)} {
			show-status "Nothing To Do !" lib-status
		} else {
			show-status "Checking not fully active !" lib-status
		}
		return {}
	}

}
proc GetLibArName {lib} {
# return the Archive name (.a) of lib
	regsub -all  {/} $lib {.} libarname
	set libarname $libarname.a
	return $libarname
}
