proc InitCheckLibProcess {numlib} {
	global Process  Obj_Lib

	set trace_type lib
	set trace_id $numlib

	trace variable Process($trace_type,checking,$trace_id) \
			w TraceLibCheck
}
proc InitCheckPrgProcess {numproj prg} {
	global Process

	set trace_type proj
	set trace_id $numproj:$prg

	trace variable Process($trace_type,checking,$trace_id) \
			w TracePrgCheck
}
proc InitAllLibProcess {status} {
	global Obj_Lib
	for {set id 1} {$id <= $Obj_Lib(number)} {incr id} {
		InitLibProcess $id $status
	}
}
proc InitLibProcess {id status} {
	global Process
	set Process(lib,winlib,$id)			$status
	set Process(lib,compiling,$id)			$status
	set Process(lib,checking,$id)			$status
	set Process(lib,selectopts,$id)			$status
	set Process(lib,selectfiles,$id,status)		$status
	set Process(lib,selectfiles,$id,value)		{}
	set Process(libar,selectfiles,$id,status)	$status
	set Process(libar,selectfiles,$id,value)	{}
}
proc ShowProcess {} {
global Process Images
	set w .proc
	catch {destroy $w}
	toplevel $w
	wm title $w "TkfPW Processes"
	wm iconbitmap $w @$Images(bitmap,proc)

	# Compiling Processes
	set id 1
	while {1} {
		if [ info exists Process(lib,compiling,$id) ] {
			set wcomp_id $w.comp$id
			frame $wcomp_id -bd 2 -relief ridge
			label $wcomp_id.name -text "Compiling Lib $id :"  -width 30 -anchor w
			label $wcomp_id.value -textvariable Process(lib,compiling,$id) \
				-width 10 -bg red -relief ridge
			pack $wcomp_id.name $wcomp_id.value -side left
			pack $wcomp_id -side top -pady 1m
			incr id
		} else {
			break
		}
	}

	# File Selection Processes
	set id 1
	while {1} {
		if [ info exists Process(lib,selectopts,$id) ] {
			set wself_id $w.self$id
			frame $wself_id -bd 2 -relief ridge
			label $wself_id.name -text "File Selection in Lib $id :" -width 30 -anchor w
			label $wself_id.value -textvariable Process(lib,selectfiles,$id,status) \
				-width 10 -bg red -relief ridge
			pack $wself_id.name $wself_id.value -side left
			pack $wself_id -side top -pady 1m
			incr id
		} else {
			break
		}
	}

	# Compiler Options Selection Processes
	set id 1
	while {1} {
		if [ info exists Process(lib,selectopts,$id) ] {
			set wselc_id $w.selc$id
			frame $wselc_id -bd 2 -relief ridge
			label $wselc_id.name -text "Compiler Options Selection in Lib $id :" -width 30 -anchor w
			label $wselc_id.value -textvariable Process(lib,selectopts,$id) \
				-width 10 -bg red -relief ridge
			pack $wselc_id.name $wselc_id.value -side left
			pack $wselc_id -side top -pady 1m
			incr id
		} else {
			break
		}
	}
}


proc InitAllProjProcess {status} {
	global Obj_Proj
	for {set id 1} {$id <= $Obj_Proj(number)} {incr id} {
		InitProjProcess $id $status
	}
}
proc InitProjProcess {id status} {
	global Process
	set Process(proj,winproj,$id)			$status
	set Process(proj,compiling,$id)			$status
	set Process(proj,selectopts,$id)		$status
	set Process(proj,selectfiles,$id,status)	$status
	set Process(proj,selectfiles,$id,value)		{}
}
#-----------------------------------------------------------------------
